
/********************************************************************
 * General utlities
 ********************************************************************/

#include <string.h>
#include <stdlib.h>
#include <strings.h>

char *strerror(int num)
{
  return strdup("my my my\n");
}



/* get word number word_no from input buffer */
int get_word (char *input, int word_no, char *output)
{
    register int i;
    int retval=1;

    if (*input == '\0') retval=0;
    if (retval) {
       for (i=0;retval && i<word_no;) {
           if (*input == '\0') retval=0;
           if (*input++ == ' ') i++; 
       }
    }
    if (retval) {
       while (*input != ' ' && *input != '\0') {
             output[0] = *input++;
             output++;
       }
    }
    output[0] = '\0';
    return retval;
}


/* function converts integers to chars */
static char int_to_char(int n)
{
char c;

c = n;
c = c+'0';
return(c);

}



/* Function stuffs ints into a message.
 * Assumes that the int is less than 999
 * and greater than -999
 */
int stuff_int_into_message (char *message, int index, int value)
{

int k;
char c;

if (value < 0) { message[index] = '-'; index++; }
value = abs(value);

k = value/100;
if (k > 0) { c = int_to_char(k); 
	     message[index] = c; 
	     index++; 
             value = value%100;
	     if (value < 10) message[index] = '0';
	     index++;
           }

k = value/10;
if (k > 0) { 
            c = int_to_char(k); 
	    message[index] = c; 
	    index++; 
             value = value%10;
           }

if ((value >= 0)  && (value < 10))
          { 
             c = int_to_char(value); 
	     message[index] = c;
	     index++; 
           }

return(index);
}

/* Function stuffs floats into a message.
 * Assumes: Only one significant digit after the decimal. 
 * Assumes that the int is less than 999.9
 * and greater than -999.9
 * Assumes that inputs such as 0.9 will contain
 * the "0" before .9 (i.e., will always be 0.9)
 */

int stuff_float_into_message (char *message, int index, float value)
{
int k;
char c;

if (value < 0) { message[index] = '-'; index++; }
value = abs(value);

k = (int) value/100;
if (k > 0) { c = int_to_char(k); 
	     message[index] = c; 
	     index++; 
             value = value - (k*100);
	     if (value < 10) 
	       {message[index] = '0';
	        index++;
	       }
           }

k = (int) value/10;
if (k > 0) { 
            c = int_to_char(k); 
	    message[index] = c; 
	    index++; 
             value = value - (k*10);
           }

k = (int) value;
if (k >= 0)
          { 
             c = int_to_char(k); 
	     message[index] = c;
	     index++; 
	     value = value - k;
	     message[index] = '.';
	     index++;
           }

k = (int) value*10;
if (k >= 0)
          { 
             c = int_to_char(k); 
	     message[index] = c;
	     index++; 
           }


return(index);

}


int stuff_char_into_message (char *message, int index, char *name)
{

int k;
char c;

k=0;
while (name[k])
          {
	     message[index] = name[k]; 
	     index++; 
	     k++;
	   }
return(index);

}
