#include <soar.h>

void
Soar_Print (the_agent, str)
     agent * the_agent;
     char * str;
{
  soar_invoke_first_callback(the_agent, PRINT_CALLBACK, (ClientData) str);
}

void
Soar_Log (the_agent, str)
     agent * the_agent;
     char * str;
{
  soar_invoke_first_callback(the_agent, LOG_CALLBACK, (ClientData) str);
}

void
Soar_LogAndPrint (the_agent, str)
     agent * the_agent;
     char * str;
{
  Soar_Log(the_agent, str);
  Soar_Print(the_agent, str);
}

void Soar_PrintToFile (the_agent, data, call_data)
     agent * the_agent;	
     soar_callback_data data;
     soar_call_data call_data;
{
  FILE * f = (FILE *) data;

  fputs((char *) call_data, f);
}

#ifdef USE_TK
void Soar_PrintToTextWidget (the_agent, data, call_data)
     agent * the_agent;	
     soar_callback_data data;
     soar_call_data call_data;
{
  Soar_TextWidgetPrintData * print_data = (Soar_TextWidgetPrintData *) data;

  Tk_PrintToTextWidget (print_data->interp,
			(ClientData) print_data->text_widget, 
			(ClientData) call_data);
}
#endif

void Soar_DiscardPrint (the_agent, data, call_data)
     agent * the_agent;
     soar_callback_data data;
     soar_call_data call_data;
{
  /* No need to do anything */
}

void Soar_AppendResult (the_agent, data, call_data)
     agent * the_agent;
     soar_callback_data data;
     soar_call_data call_data;
{
  Tcl_AppendResult(the_agent->interpreter, 
	           (char *) call_data, 
	           (char *) NULL);
}

void Soar_FClose (FILE * f)
{
  fclose(f);
}
