/*************************************************************************/
/*									 */
/*	Routines for displaying, building, saving and restoring trees	 */
/*	-------------------------------------------------------------	 */
/*									 */
/*************************************************************************/


#include "defns.i"
#include "types.i"
#include "extern.i"


#define	Tab		"|   "
#define	TabSize		4
#define	Width		80	/* approx max width of printed trees */

	/*  If lines look like getting too long while a tree is being
	    printed, subtrees are broken off and printed separately after
	    the main tree is finished	 */

short	Subtree;		/* highest subtree to be printed */
Tree	Subdef[500];		/* pointers to subtrees */

FILE	*Tf = 0, *fopen();	/* file pointer for tree i/o */
char	Fn[500];		/* file name */




/*************************************************************************/
/*									 */
/*	Stream characters to/from file Tf from/to an address		 */
/*									 */
/*************************************************************************/


StreamOut(s, n)
     String s;
     int n;
{
    while ( n-- ) putc(*s++, Tf);
}



StreamIn(s, n)
     String s;
     int n;
{
    while ( n-- ) *s++ = getc(Tf);
}


